#include <stdio.h>

#define KEY 0x12
#define BUFSZ 16384

int
main(int argc, char** argv)
{
	if (argc != 3) {
		fprintf(stderr, "Usage: %s input.zip output.zip\n", argv[0]);
		return 1;
	}

	FILE* in = fopen(argv[1], "rb");
	if (!in) {
		perror("Failed to open input file");
		return 1;
	}

	FILE* out = fopen(argv[2], "wb");
	if (!out) {
		perror("Failed to open output file");
		return 1;
	}

	char buf[BUFSZ];
	while (feof(in) == 0) {
		size_t rsz = fread(buf, 1, BUFSZ, in);
		if (rsz != BUFSZ && ferror(in) != 0) {
			fprintf(stderr, "Error reading input!\n");
			return 1;
		}
		for (size_t i = 0; i < rsz; ++i) {
			buf[i] ^= KEY;
		}
		size_t wsz = fwrite(buf, 1, rsz, out);
		if (wsz != rsz) {
			fprintf(stderr,"Error writing output!\n");
			return 1;
		}
	}

	fclose(in);
	fclose(out);

	return 0;
}

